// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: capbankmodule/capbankmodule.proto

package openfmb.capbankmodule;

/**
 * <pre>
 * Curve shape setting (FC=SP) (CSG_SP)
 * </pre>
 *
 * Protobuf type {@code capbankmodule.CapBankCSG}
 */
public final class CapBankCSG extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:capbankmodule.CapBankCSG)
    CapBankCSGOrBuilder {
private static final long serialVersionUID = 0L;
  // Use CapBankCSG.newBuilder() to construct.
  private CapBankCSG(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private CapBankCSG() {
    crvPts_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new CapBankCSG();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankCSG_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankCSG_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.capbankmodule.CapBankCSG.class, openfmb.capbankmodule.CapBankCSG.Builder.class);
  }

  public static final int CRVPTS_FIELD_NUMBER = 1;
  @SuppressWarnings("serial")
  private java.util.List<openfmb.capbankmodule.CapBankPoint> crvPts_;
  /**
   * <pre>
   * The array with the points specifying a curve shape.
   * </pre>
   *
   * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public java.util.List<openfmb.capbankmodule.CapBankPoint> getCrvPtsList() {
    return crvPts_;
  }
  /**
   * <pre>
   * The array with the points specifying a curve shape.
   * </pre>
   *
   * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public java.util.List<? extends openfmb.capbankmodule.CapBankPointOrBuilder> 
      getCrvPtsOrBuilderList() {
    return crvPts_;
  }
  /**
   * <pre>
   * The array with the points specifying a curve shape.
   * </pre>
   *
   * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public int getCrvPtsCount() {
    return crvPts_.size();
  }
  /**
   * <pre>
   * The array with the points specifying a curve shape.
   * </pre>
   *
   * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.capbankmodule.CapBankPoint getCrvPts(int index) {
    return crvPts_.get(index);
  }
  /**
   * <pre>
   * The array with the points specifying a curve shape.
   * </pre>
   *
   * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.capbankmodule.CapBankPointOrBuilder getCrvPtsOrBuilder(
      int index) {
    return crvPts_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < crvPts_.size(); i++) {
      output.writeMessage(1, crvPts_.get(i));
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < crvPts_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, crvPts_.get(i));
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.capbankmodule.CapBankCSG)) {
      return super.equals(obj);
    }
    openfmb.capbankmodule.CapBankCSG other = (openfmb.capbankmodule.CapBankCSG) obj;

    if (!getCrvPtsList()
        .equals(other.getCrvPtsList())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getCrvPtsCount() > 0) {
      hash = (37 * hash) + CRVPTS_FIELD_NUMBER;
      hash = (53 * hash) + getCrvPtsList().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.capbankmodule.CapBankCSG parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankCSG parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankCSG parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.capbankmodule.CapBankCSG parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.capbankmodule.CapBankCSG prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Curve shape setting (FC=SP) (CSG_SP)
   * </pre>
   *
   * Protobuf type {@code capbankmodule.CapBankCSG}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:capbankmodule.CapBankCSG)
      openfmb.capbankmodule.CapBankCSGOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankCSG_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankCSG_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.capbankmodule.CapBankCSG.class, openfmb.capbankmodule.CapBankCSG.Builder.class);
    }

    // Construct using openfmb.capbankmodule.CapBankCSG.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      if (crvPtsBuilder_ == null) {
        crvPts_ = java.util.Collections.emptyList();
      } else {
        crvPts_ = null;
        crvPtsBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000001);
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.capbankmodule.Capbankmodule.internal_static_capbankmodule_CapBankCSG_descriptor;
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankCSG getDefaultInstanceForType() {
      return openfmb.capbankmodule.CapBankCSG.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankCSG build() {
      openfmb.capbankmodule.CapBankCSG result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.capbankmodule.CapBankCSG buildPartial() {
      openfmb.capbankmodule.CapBankCSG result = new openfmb.capbankmodule.CapBankCSG(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(openfmb.capbankmodule.CapBankCSG result) {
      if (crvPtsBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          crvPts_ = java.util.Collections.unmodifiableList(crvPts_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.crvPts_ = crvPts_;
      } else {
        result.crvPts_ = crvPtsBuilder_.build();
      }
    }

    private void buildPartial0(openfmb.capbankmodule.CapBankCSG result) {
      int from_bitField0_ = bitField0_;
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.capbankmodule.CapBankCSG) {
        return mergeFrom((openfmb.capbankmodule.CapBankCSG)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.capbankmodule.CapBankCSG other) {
      if (other == openfmb.capbankmodule.CapBankCSG.getDefaultInstance()) return this;
      if (crvPtsBuilder_ == null) {
        if (!other.crvPts_.isEmpty()) {
          if (crvPts_.isEmpty()) {
            crvPts_ = other.crvPts_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureCrvPtsIsMutable();
            crvPts_.addAll(other.crvPts_);
          }
          onChanged();
        }
      } else {
        if (!other.crvPts_.isEmpty()) {
          if (crvPtsBuilder_.isEmpty()) {
            crvPtsBuilder_.dispose();
            crvPtsBuilder_ = null;
            crvPts_ = other.crvPts_;
            bitField0_ = (bitField0_ & ~0x00000001);
            crvPtsBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getCrvPtsFieldBuilder() : null;
          } else {
            crvPtsBuilder_.addAllMessages(other.crvPts_);
          }
        }
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              openfmb.capbankmodule.CapBankPoint m =
                  input.readMessage(
                      openfmb.capbankmodule.CapBankPoint.parser(),
                      extensionRegistry);
              if (crvPtsBuilder_ == null) {
                ensureCrvPtsIsMutable();
                crvPts_.add(m);
              } else {
                crvPtsBuilder_.addMessage(m);
              }
              break;
            } // case 10
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private java.util.List<openfmb.capbankmodule.CapBankPoint> crvPts_ =
      java.util.Collections.emptyList();
    private void ensureCrvPtsIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        crvPts_ = new java.util.ArrayList<openfmb.capbankmodule.CapBankPoint>(crvPts_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.capbankmodule.CapBankPoint, openfmb.capbankmodule.CapBankPoint.Builder, openfmb.capbankmodule.CapBankPointOrBuilder> crvPtsBuilder_;

    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<openfmb.capbankmodule.CapBankPoint> getCrvPtsList() {
      if (crvPtsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(crvPts_);
      } else {
        return crvPtsBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public int getCrvPtsCount() {
      if (crvPtsBuilder_ == null) {
        return crvPts_.size();
      } else {
        return crvPtsBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.capbankmodule.CapBankPoint getCrvPts(int index) {
      if (crvPtsBuilder_ == null) {
        return crvPts_.get(index);
      } else {
        return crvPtsBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setCrvPts(
        int index, openfmb.capbankmodule.CapBankPoint value) {
      if (crvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCrvPtsIsMutable();
        crvPts_.set(index, value);
        onChanged();
      } else {
        crvPtsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setCrvPts(
        int index, openfmb.capbankmodule.CapBankPoint.Builder builderForValue) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        crvPts_.set(index, builderForValue.build());
        onChanged();
      } else {
        crvPtsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addCrvPts(openfmb.capbankmodule.CapBankPoint value) {
      if (crvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCrvPtsIsMutable();
        crvPts_.add(value);
        onChanged();
      } else {
        crvPtsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addCrvPts(
        int index, openfmb.capbankmodule.CapBankPoint value) {
      if (crvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCrvPtsIsMutable();
        crvPts_.add(index, value);
        onChanged();
      } else {
        crvPtsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addCrvPts(
        openfmb.capbankmodule.CapBankPoint.Builder builderForValue) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        crvPts_.add(builderForValue.build());
        onChanged();
      } else {
        crvPtsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addCrvPts(
        int index, openfmb.capbankmodule.CapBankPoint.Builder builderForValue) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        crvPts_.add(index, builderForValue.build());
        onChanged();
      } else {
        crvPtsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addAllCrvPts(
        java.lang.Iterable<? extends openfmb.capbankmodule.CapBankPoint> values) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, crvPts_);
        onChanged();
      } else {
        crvPtsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearCrvPts() {
      if (crvPtsBuilder_ == null) {
        crvPts_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        crvPtsBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder removeCrvPts(int index) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        crvPts_.remove(index);
        onChanged();
      } else {
        crvPtsBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.capbankmodule.CapBankPoint.Builder getCrvPtsBuilder(
        int index) {
      return getCrvPtsFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.capbankmodule.CapBankPointOrBuilder getCrvPtsOrBuilder(
        int index) {
      if (crvPtsBuilder_ == null) {
        return crvPts_.get(index);  } else {
        return crvPtsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<? extends openfmb.capbankmodule.CapBankPointOrBuilder> 
         getCrvPtsOrBuilderList() {
      if (crvPtsBuilder_ != null) {
        return crvPtsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(crvPts_);
      }
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.capbankmodule.CapBankPoint.Builder addCrvPtsBuilder() {
      return getCrvPtsFieldBuilder().addBuilder(
          openfmb.capbankmodule.CapBankPoint.getDefaultInstance());
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.capbankmodule.CapBankPoint.Builder addCrvPtsBuilder(
        int index) {
      return getCrvPtsFieldBuilder().addBuilder(
          index, openfmb.capbankmodule.CapBankPoint.getDefaultInstance());
    }
    /**
     * <pre>
     * The array with the points specifying a curve shape.
     * </pre>
     *
     * <code>repeated .capbankmodule.CapBankPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<openfmb.capbankmodule.CapBankPoint.Builder> 
         getCrvPtsBuilderList() {
      return getCrvPtsFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.capbankmodule.CapBankPoint, openfmb.capbankmodule.CapBankPoint.Builder, openfmb.capbankmodule.CapBankPointOrBuilder> 
        getCrvPtsFieldBuilder() {
      if (crvPtsBuilder_ == null) {
        crvPtsBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            openfmb.capbankmodule.CapBankPoint, openfmb.capbankmodule.CapBankPoint.Builder, openfmb.capbankmodule.CapBankPointOrBuilder>(
                crvPts_,
                ((bitField0_ & 0x00000001) != 0),
                getParentForChildren(),
                isClean());
        crvPts_ = null;
      }
      return crvPtsBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:capbankmodule.CapBankCSG)
  }

  // @@protoc_insertion_point(class_scope:capbankmodule.CapBankCSG)
  private static final openfmb.capbankmodule.CapBankCSG DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.capbankmodule.CapBankCSG();
  }

  public static openfmb.capbankmodule.CapBankCSG getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<CapBankCSG>
      PARSER = new com.google.protobuf.AbstractParser<CapBankCSG>() {
    @java.lang.Override
    public CapBankCSG parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<CapBankCSG> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<CapBankCSG> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.capbankmodule.CapBankCSG getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

